"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _constants_1 = require("../constants");
exports.cleanRuleRawsBefore = function (node) {
    if (node && node.type === _constants_1.RULE_TYPE) {
        node.raws.before = '\n\n' + node.raws.before.replace(/\n/g, '');
    }
};
exports.cleanRules = function () {
    var rules = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        rules[_i] = arguments[_i];
    }
    rules.forEach(function (rule) {
        var prev = rule.prev();
        if (prev && prev.type !== _constants_1.COMMENT_TYPE) {
            exports.cleanRuleRawsBefore(rule);
        }
        rule.walk(function (node) {
            if (node.type === _constants_1.DECLARATION_TYPE) {
                if (node.raws && node.raws.value && _constants_1.RTL_COMMENT_REGEXP.test(node.raws.value.raw)) {
                    delete node.raws.value;
                    node.value = node.value.trim();
                }
            }
        });
    });
};
exports.appendRules = function (rules) {
    rules.forEach(function (_a) {
        var rule = _a.rule, ruleLTR = _a.ruleLTR, ruleRTL = _a.ruleRTL, ruleBoth = _a.ruleBoth;
        ruleBoth && ruleBoth.nodes.length && rule.after(ruleBoth);
        ruleRTL && ruleRTL.nodes.length && rule.after(ruleRTL);
        ruleLTR && ruleLTR.nodes.length && rule.after(ruleLTR);
        if (rule.nodes.length === 0) {
            rule.remove();
        }
        exports.cleanRules(rule, ruleLTR, ruleRTL, ruleBoth);
    });
};
exports.appendKeyFrames = function (rules) {
    rules.forEach(function (_a) {
        var atRule = _a.atRule, atRuleFlipped = _a.atRuleFlipped;
        atRule.after(atRuleFlipped);
        exports.cleanRules(atRule, atRuleFlipped);
    });
};
